<template>
  <el-main style="overflow: hidden">
    <el-form ref="form" :model="form" :disabled="form.registerState == '1'">
      <el-row>
        <el-col :span="12">
          <el-form-item label="案件名称 " :label-width="formLabelWidth">
            <el-input v-model="form.caseName" autocomplete="off"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="案号 " :label-width="formLabelWidth">
            <el-input v-model="form.caseNum" autocomplete="off"></el-input>
          </el-form-item>
        </el-col>
      </el-row>

      <el-row>
        <el-col :span="12">
          <el-form-item label="开始时间 " :label-width="formLabelWidth">
            <el-date-picker
              v-model="form.beginTime"
              type="datetime"
              :value-format="`yyyy-MM-dd HH:mm:ss`"
              placeholder="选择日期"
              style="width: 100%"
            >
            </el-date-picker>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="结束时间 " :label-width="formLabelWidth">
            <el-date-picker
              v-model="form.endTime"
              type="datetime"
              :value-format="`yyyy-MM-dd HH:mm:ss`"
              placeholder="选择日期"
              style="width: 100%"
            >
            </el-date-picker>
          </el-form-item>
        </el-col>
      </el-row>

      <el-form-item label="地点 " :label-width="formLabelWidth">
        <el-input v-model="form.place" autocomplete="off"></el-input>
      </el-form-item>

      <el-form-item label="集体讨论原因 " :label-width="formLabelWidth">
        <el-input
          type="textarea"
          v-model="form.brainstormReasons"
          autocomplete="off"
        ></el-input>
      </el-form-item>

      <el-row>
        <el-col :span="12">
          <el-form-item label="主持人 " :label-width="formLabelWidth">
            <el-input v-model="form.compere" autocomplete="off"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="主持人职务 " :label-width="formLabelWidth">
            <el-input
              v-model="form.comperePost"
              autocomplete="off"
            ></el-input>
          </el-form-item>
        </el-col>
      </el-row>

      <el-row>
        <el-col :span="12">
          <el-form-item label="记录人 " :label-width="formLabelWidth">
            <el-input v-model="form.recorder" autocomplete="off"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="记录人职务 " :label-width="formLabelWidth">
            <el-input
              v-model="form.recorderPost"
              autocomplete="off"
            ></el-input>
          </el-form-item>
        </el-col>
      </el-row>

      <el-form-item label="参加人员及职务 " :label-width="formLabelWidth">
        <el-input
          type="textarea"
          v-model="form.participant"
          autocomplete="off"
        ></el-input>
      </el-form-item>

      <el-form-item label="列席人员 " :label-width="formLabelWidth">
        <el-input
          type="textarea"
          v-model="form.attendee"
          autocomplete="off"
        ></el-input>
      </el-form-item>

      <el-form-item label="案件情况 " :label-width="formLabelWidth">
        <el-input
          v-model="form.reportCondition"
          type="textarea"
          autocomplete="off"
        ></el-input>
      </el-form-item>

      <el-form-item label="汇报听证情况 " :label-width="formLabelWidth">
        <el-input
          v-model="form.hearingCondition"
          type="textarea"
          autocomplete="off"
        ></el-input>
      </el-form-item>

      <el-form-item label="审核情况 " :label-width="formLabelWidth">
        <el-input
          v-model="form.checkCondition"
          type="textarea"
          autocomplete="off"
        ></el-input>
      </el-form-item>

      <el-form-item label="人员意见和理由 " :label-width="formLabelWidth">
        <el-input
          v-model="form.opinionAndReason"
          type="textarea"
          autocomplete="off"
        ></el-input>
      </el-form-item>

      <el-form-item label="讨论记录 " :label-width="formLabelWidth">
        <el-input
          v-model="form.discussionRecord"
          type="textarea"
          autocomplete="off"
        ></el-input>
      </el-form-item>

      <el-form-item label="讨论结论性意见 " :label-width="formLabelWidth">
        <el-input
          v-model="form.observations"
          type="textarea"
          autocomplete="off"
        ></el-input>
      </el-form-item>
      <el-row>
        <el-col :span="12">
          <el-form-item label="记录时间 " :label-width="formLabelWidth">
            <el-date-picker
              v-model="form.reportDate"
              type="date"
              :value-format="`yyyy-MM-dd`"
              placeholder="选择日期"
              style="width: 100%"
            >
            </el-date-picker>
          </el-form-item>
        </el-col>
      </el-row>

      <WordView ref="wordInfo" :isShowYulan="showView" @cancel="cancelWord"></WordView>
    </el-form>
    <div style="text-align: center">
      <el-button v-if="isFinish!='2'" plain @click="dataFormSubmit('0')">保存</el-button>
      <el-button v-if="isFinish!='2'" type="warning" plain @click="dataFormSubmit('1')">定稿</el-button>
      <el-button type="primary" plain @click="viewVord(form)">预览</el-button>
      <el-button type="success" plain @click="downloadWord(form)">下载</el-button>
    </div>
  </el-main>
</template>

<script>
  import WordView from "@/views/News/word-view";
  import {getObj, saveObj} from "@/api/News/caseGroupDiscussWord";
  import moment from "moment";

  export default {
    name: "caseGroupDiscussWord",
    props: ['isShowYulan', 'id', 'isFinish', 'processId', 'title'],
    components: {
      WordView
    },
    data() {
      return {
        showView: false,
        form: {
          unitName: "",
          litigant: "",
          place: "",
          brainstormReasons: "",
          caseName: "",
          hearingTime: "",
          host: "",
          hearingOfficer: "",
          recorder: "",
          phoneName: "",
          phone: "",
          notificationTime: "",
          reportDate: "",
          litigantPhone: "",
          observations:"",
          discussionRecord:""
        },
        formLabelWidth: "140px",
      };
    },
    created() {
      this.init()
    },
    methods: {
      init() {
        getObj(this.id).then((res) => {
          if (res.data.code == 0) {
            // 转换null为""
            let v = res.data.data;
            for (let attr in v) {
              if (v[attr] == null) {
                v[attr] = "";
              }
            }
            let str = JSON.stringify(v);
            let data = JSON.parse(str);
            this.form = data;
          }
        });
      },
      dataFormSubmit(type) {
        this.$refs['form'].validate((valid) => {
          if (valid) {
            let obj = this;
            if ("1" == type) {
              this.$confirm('保存为定稿将不能修改，是否继续？', '提示', {
                confirmButtonText: '是',
                cancelButtonText: '否',
                type: 'warning'
              }).then(function () {
                obj.form.registerState = type;
                obj.form.registerId = obj.id;
                obj.form.processId = obj.processId;
                saveObj(obj.form).then((res) => {
                  // this.submitLoading = false;
                  obj.$message.success('操作成功');
                  obj.cancel();
                  obj.$emit('getDataList');
                })
              })
            } else {
              obj.form.registerState = type;
              obj.form.registerId = obj.id;
              obj.form.processId = obj.processId;
              saveObj(obj.form).then((res) => {
                // this.submitLoading = false;
                obj.$message.success("操作成功");
                obj.cancel();
                obj.$emit('getDataList');
              })
            }
          }
        })
      },
      cancel() {
        this.$emit('cancel', false);
      },
      cancelWord() {
        this.showView = false;
      },
      viewVord(data) {
        if(data.registerState == null || data.registerState == ""){
          //预览前先进行保存
          data.registerState = '0';
          data.registerId = this.id;
          data.processId = this.processId;
          saveObj(data).then((res) => {
          })
        }
        //↓↓↓↓↓↓以下部分根据具体业务修改↓↓↓↓↓↓
        //格式转换
        let wordData = this.transforData(data);
        //↑↑↑↑↑↑以上部分根据具体业务修改↑↑↑↑↑↑
        this.showView = true;
        this.$nextTick(() => {
          this.$refs.wordInfo.init(wordData, "/wordes/caseGroupDiscussWord.docx");
        })
      },
      downloadWord(data) {
        if(data.registerState == null || data.registerState == ""){
          //预览前先进行保存
          data.registerState = '0';
          data.registerId = this.id;
          data.processId = this.processId;
          saveObj(data).then((res) => {
          })
        }
        let wordData = this.transforData(data);
        WordView.methods.exportDoc(wordData, "/wordes/caseGroupDiscussWord.docx", this.title+'.docx');
      },
      transforData(obj) {
        let s = JSON.stringify(obj);
        let data = JSON.parse(s);
        if (data.beginTime != '' && data.beginTime != null) {
          data.beginTime = moment(data.beginTime).format('YYYY年MM月DD日HH时mm分');
        } else {
          data.beginTime = '  年  月  日  时  分'
        }

        if (data.endTime != '' && data.endTime != null) {
          data.endTime = moment(data.endTime).format('HH时mm分');
        } else {
          data.endTime = '  时  分'
        }

        if (data.reportDate != '' && data.reportDate != null) {
          data.reportDate = moment(data.reportDate).format('YYYY年MM月DD日');
        } else {
          data.reportDate = '  年  月  日'
        }

        return data;
      }
    }
  }
</script>

<style scoped>

</style>
